Loading...
Searching...
No Matches
juce::SmoothedValue< FloatType, SmoothingType > Class Template Reference

## Detailed Description

template<typename FloatType, typename SmoothingType = ValueSmoothingTypes::Linear>
class juce::SmoothedValue< FloatType, SmoothingType >

A utility class for values that need smoothing to avoid audio glitches.

A ValueSmoothingTypes::Linear template parameter selects linear smoothing, which increments the SmoothedValue linearly towards its target value.

SmoothedValue<float, ValueSmoothingTypes::Linear> yourSmoothedValue;
juce::SmoothedValue::SmoothedValue
SmoothedValue() noexcept
Constructor.
Definition juce_SmoothedValue.h:243

A ValueSmoothingTypes::Multiplicative template parameter selects multiplicative smoothing increments towards the target value.

SmoothedValue<float, ValueSmoothingTypes::Multiplicative> yourSmoothedValue;

Multiplicative smoothing is useful when you are dealing with exponential/logarithmic values like volume in dB or frequency in Hz. For example a 12 step ramp from 440.0 Hz (A4) to 880.0 Hz (A5) will increase the frequency with an equal temperament tuning across the octave. A 10 step smoothing from 1.0 (0 dB) to 3.16228 (10 dB) will increase the value in increments of 1 dB.

Note that when you are using multiplicative smoothing you cannot ever reach a target value of zero!

The documentation for this class was generated from the following file:

- juce_audio_basics/utilities/juce_SmoothedValue.h

Inheritance diagram for juce::SmoothedValue< FloatType, SmoothingType >:

## Public Member Functions

| SmoothedValue () noexcept
| Constructor.
| SmoothedValue (FloatType initialValue) noexcept
| Constructor.
void | reset (double sampleRate, double rampLengthInSeconds) noexcept
| Reset to a new sample rate and ramp length.
void | reset (int numSteps) noexcept
| Set a new ramp length directly in samples.
void | setTargetValue (FloatType newValue) noexcept
| Set the next value to ramp towards.
FloatType | getNextValue () noexcept
| Compute the next value.
FloatType | skip (int numSamples) noexcept
| Skip the next numSamples samples.
Public Member Functions inherited from juce::SmoothedValueBase< SmoothedValue< FloatType, ValueSmoothingTypes::Linear > >
| SmoothedValueBase ()=default
| Constructor.
bool | isSmoothing () const noexcept
| Returns true if the current value is currently being interpolated.
FloatType | getCurrentValue () const noexcept
| Returns the current value of the ramp.
FloatType | getTargetValue () const noexcept
| Returns the target value towards which the smoothed value is currently moving.
void | setCurrentAndTargetValue (FloatType newValue)
| Sets the current value and the target value.
void | applyGain (FloatType *samples, int numSamples) noexcept
| Applies a smoothed gain to a stream of samples S[i] *= gain.

## Additional Inherited Members

Public Types inherited from juce::SmoothedValueBase< SmoothedValue< FloatType, ValueSmoothingTypes::Linear > >
using | FloatType
Protected Attributes inherited from juce::SmoothedValueBase< SmoothedValue< FloatType, ValueSmoothingTypes::Linear > >
FloatType | currentValue
FloatType | target
int | countdown

## Constructors and Destructors

## SmoothedValue() [1/2]

template<typename FloatType, typename SmoothingType = ValueSmoothingTypes::Linear>

juce::SmoothedValue< FloatType, SmoothingType >::SmoothedValue | ( |  | ) |

inline noexcept

Constructor.

## SmoothedValue() [2/2]

template<typename FloatType, typename SmoothingType = ValueSmoothingTypes::Linear>

juce::SmoothedValue< FloatType, SmoothingType >::SmoothedValue | ( | FloatType | initialValue | ) |

inline noexcept

Constructor.

## Member Functions

## reset() [1/2]

template<typename FloatType, typename SmoothingType = ValueSmoothingTypes::Linear>

void juce::SmoothedValue< FloatType, SmoothingType >::reset | ( | double | sampleRate,
|  | double | rampLengthInSeconds )

inline noexcept

Reset to a new sample rate and ramp length.

Parameters

  sampleRate | The sample rate
  rampLengthInSeconds | The duration of the ramp in seconds

Referenced by juce::SmoothedValue< FloatType, ValueSmoothingTypes::Linear >::reset().

## reset() [2/2]

template<typename FloatType, typename SmoothingType = ValueSmoothingTypes::Linear>

void juce::SmoothedValue< FloatType, SmoothingType >::reset | ( | int | numSteps | ) |

inline noexcept

Set a new ramp length directly in samples.

Parameters

  numSteps | The number of samples over which the ramp should be active

## setTargetValue()

template<typename FloatType, typename SmoothingType = ValueSmoothingTypes::Linear>

void juce::SmoothedValue< FloatType, SmoothingType >::setTargetValue | ( | FloatType | newValue | ) |

inline noexcept

Set the next value to ramp towards.

Parameters

  newValue | The new target value

## getNextValue()

template<typename FloatType, typename SmoothingType = ValueSmoothingTypes::Linear>

FloatType juce::SmoothedValue< FloatType, SmoothingType >::getNextValue | ( |  | ) |

inline noexcept

Compute the next value.

Returns
  Smoothed value

## skip()

template<typename FloatType, typename SmoothingType = ValueSmoothingTypes::Linear>

FloatType juce::SmoothedValue< FloatType, SmoothingType >::skip | ( | int | numSamples | ) |

inline noexcept

Skip the next numSamples samples.

This is identical to calling getNextValue numSamples times. It returns the new current value.

See also
  getNextValue

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited